# include <stdio.h>
# include <stdlib.h>
# include <string.h>

# include "size.h"
# include "def.h"
# include "extern.h"

extern char * str_buf_head;
extern char * str_buf_end;

extern FILE * yyin;

extern void unparse(union Node * ptr);
extern void crossref(void);

char cmdline_buffer[127];

struct yysymbol token[MaxK];
struct yysymbol type[MaxK];

int token_num = 0;
int type_num = 0;

FILE * source = stdin;
FILE * output = stdout;

union Node * globalptr;

void catarg(int argc, char * argv[], char * buffer) 
{
  int i;
  char * str;
  str = buffer;
  for (i=1; i<argc; i++){
    strcpy(str,argv[i]);
    str += strlen(argv[i]);
    if (i==(argc-1)) *str='\0';
      else *str=' '; 
    str ++;
    }
}

cmdwrap()
{
  return(1);
}

/******************************************************************/

int yysymbolcmp(struct yysymbol * ptr1, struct yysymbol * ptr2)
{
  return(strcmp(ptr1->name, ptr2->name));
}
 
main (int argc, char * argv[])
{
  catarg(argc, argv, cmdline_buffer);

  str_buf_head=cmdline_buffer;
  str_buf_end=str_buf_head + strlen(cmdline_buffer) + 1;

  cmdlex();
  yyin = source;

  yylex();

  qsort(token, token_num+1, sizeof(struct yysymbol), (void *)yysymbolcmp);
  qsort(type, type_num+1, sizeof(struct yysymbol), (void *)yysymbolcmp);

  { 
    int i;
    for(i=0;i<token_num;i++){
      if (strcmp(token[i].name,token[i+1].name)==0) {
	printf("the %d\tth token: %s is repeated.\n", i, token[i].name);
	exit (0);
      }
    };
    for(i=0;i<type_num;i++){
      if (strcmp(type[i].name,type[i+1].name)==0) {
	printf("the %d\tth type: %s is repeated.\n", i, type[i].name);
	exit (0);
      }
    }
  };

  { 
    int i;
    for(i=1;i<=token_num;i++){
      printf("the %d\tth token: %s\n", i, token[i].name);
    };
    for(i=1;i<=type_num;i++){
      printf("the %d\tth type: %s\t type: %s\n", i, type[i].name, type[i].yytype);
    }
  };

  yyparse();

  fprintf(output, "<HR>\n<H2 align=center>Gramer rule</H2>\n<HR>\n\n");

  unparse(globalptr);

  crossref();

}










